# -*- coding: utf-8 -*-
import datetime
import sys
import requests
from ops.plog import define_logger
import logging


define_logger("/data/logs/ops/daily_report_cron.log")

log = logging.getLogger(__name__)


def get_url(url):
    r = requests.get(url)
    if r.status_code == requests.codes.ok:
        return True
    else:
        log.error(f"connect {url} failed, {r.content}", exc_info=True)
        return False


def main():
    try:
        project = sys.argv[1]
    except Exception:
        log.error("PLS inpit project!")
        raise Exception("PLS inpit project")
    if len(sys.argv) != 3:
        times = (datetime.date.today() - datetime.timedelta(days=1)).strftime('%Y-%m-%d')
    else:
        times = sys.argv[2]

    if str(project) == '2001':
        url = f"http://10.10.3.10:6700/send-dailyreport?day={times}&project=2001"
    else:
        url = f"http://10.10.3.10:6700/send-dailyreport?day={times}"

    if get_url(url):
        log.info(f"connect {project} {times} success!")
    else:
        log.error(f"send report  {project} {times} failed!")


if __name__ == "__main__":
    main()
