# -*- coding: utf-8 -*-
import datetime
import sys
import requests
from ops.plog import define_logger
import logging


define_logger("/data/logs/ops/weekly_report_cron.log")

log = logging.getLogger(__name__)


def get_url(url):
    r = requests.get(url)
    if r.status_code == requests.codes.ok:
        return True
    else:
        log.error(f"connect {url} failed, {r.content}", exc_info=True)
        return False


def main():

    if len(sys.argv) == 2:
        times = sys.argv[2]
    else:
        times = (datetime.date.today() - datetime.timedelta(days=2)).strftime('%Y-%m-%d')

    url = f"http://10.10.3.10:6700/send-tapweekly?day={times}"

    if get_url(url):
        log.info(f"connect  {times} success!")
    else:
        log.error(f"send report  {times} failed!")


if __name__ == "__main__":
    main()
