# -*- coding: utf-8 -*-
from ops.mmysql import MysqlBase
from ops.mtga import FromTga
from ops.plog import define_logger
import logging
import datetime
import pdb
define_logger("/data/logs/ops/split_tags.log")
log = logging.getLogger(__name__)

db_conf = {'user': 'mytga', 'pswd': 'gzVwh4HGR68G', 'host': '10.10.3.5', 'db': 'external_data'}


class SplitTapTags:
    def __init__(self, day):
        self.db_conn = MysqlBase(**db_conf)
        self.url = "http://10.10.3.17:8992/querySql"
        self.api_secret = "n9H4R32ZcjtSeN89ljCY6ESzTmOlnwwnOB3r4YsggnP5M1AXLtKtiS4sS1KKLOEQ"
        self.tga = FromTga(url=self.url, token=self.api_secret)
        self.type = ['new', 'reserve']
        self.day = day


    def get_data(self):
        all = dict()
        for types in self.type:
            all[types] = {}
            sql = f"""SELECT tags FROM v_event_25 where catename='{types}' and "$part_date"='{self.day}' """
            tags = self.tga.get_data(sql)
            if tags:
                for line in tags:
                    if line:
                        try:
                            for item in line[0].split(","):
                                all[types][item] = all[types].get(item, 0) + 1
                        except Exception:
                            log.error(f"split {line} failed!", exc_info=True)
        #print(all)
        return all

    def write2db(self, data):
        db_data = {}
        tables_name = "tap_tags_counts"
        for key in data.keys():
            for k in data[key]:
                db_data['type'] = key
                db_data['name'] = k
                db_data['date'] = self.day
                db_data['nums'] = data[key][k]
                try:
                    self.db_conn.insert(tables_name, db_data)
                except Exception:
                    log.error(f"insert {db_data} failed!", exc_info=True)


    def run(self):
        data = self.get_data()
        #pdb.set_trace()
        self.write2db(data)


def main():
    import sys
    if len(sys.argv) == 2:
        day = sys.argv[1]
    else:
        day = (datetime.date.today() - datetime.timedelta(days=1)).strftime('%Y-%m-%d')
    stt = SplitTapTags(day)
    stt.run()


if __name__ == "__main__":
    main()
