# -*- coding: utf-8 -*-
from ops.mtga import FromTga
from ops.plog import define_logger
from ops.mmysql import MysqlBase
import logging
import datetime
import pdb
import sys
import json

define_logger("/data/logs/ops/taptap_daily_taps.log")
log = logging.getLogger(__name__)
import sys


class TapTapReport:
    def __init__(self, day):
        self.db_conf = {'user': 'mytga', 'pswd': 'gzVwh4HGR68G', 'host': '10.10.3.5', 'db': 'external_data'}
        self.url = "http://10.10.3.17:8992/querySql"
        self.api_secret = "n9H4R32ZcjtSeN89ljCY6ESzTmOlnwwnOB3r4YsggnP5M1AXLtKtiS4sS1KKLOEQ"
        self.tga = FromTga(url=self.url, token=self.api_secret)
        self.day = day  # self.bday = (datetime.datetime.strptime(self.day, "%Y-%m-%d") - datetime.timedelta(days=1)).strftime(  # '%Y-%m-%d')


    def get_tags(self):
        sql = f"""SELECT
            catename,
            tags,
            "order" 
        FROM
            v_event_25 
        where
            "$part_date"='{self.day}'"""
        data = self.tga.get_data(sql)
        tags_data = {}
        if data:
            for line in data:
                try:
                    catename, tags, order = line
                    if catename not in tags_data.keys():
                        tags_data[catename] = {}
                    temp_dict = tags_data.get(catename, {})
                    #print(f"base temp={temp_dict}")
                    for tag in tags.split(","):
                        temp_dict[tag] = temp_dict.get(tag, 0) + self.order2score(order)
                    #print(f"old={tags_data},type={catename},new={temp_dict}")
                    # pdb.set_trace()
                    tags_data[catename].update(temp_dict)
                except Exception:
                    log.error(f"split {line} failed", exc_info=True)
        return tags_data

    def write2db(self, data):
        table_name = "taptap_tags_daily"
        db = MysqlBase(**self.db_conf)
        for catename in data.keys():
            temp = {}
            temp["catename"] = catename
            temp["day"] = self.day
            for name in data.get(catename).keys():
                temp["score"] = data.get(catename)[name]
                temp["type"] = name
                db.insert(table_name, temp)




    def order2score(self, order):
        try:
            order_int = int(order)
            if order_int <= 10 and order_int >= 1:
                return 5
            elif order_int > 10 and order_int <= 50:
                return 3
            elif order_int <= 200:
                return 2
            else:
                return 1
        except Exception:
            log.error(f"PLS check order={order} ", exc_info=True)
            return 0


def get_days(bengin):
    all_days = []
    # end = (datetime.date.today() - datetime.timedelta(days=2)).strftime('%Y-%m-%d')

    for i in range(1, 100):
        n = i + 2
        next_day = (datetime.date.today() - datetime.timedelta(days=n)).strftime('%Y-%m-%d')
        if next_day == bengin:
            return all_days
        else:
            all_days.append(next_day)


def main():
    if len(sys.argv) == 2:
        day = sys.argv[1]
    else:
        day = (datetime.date.today() - datetime.timedelta(days=1)).strftime('%Y-%m-%d')

    # begin = "2019-10-15"
    # all_days = get_days(begin)
    # print(all_days)

    tap = TapTapReport(day)
    data = tap.get_tags()
    tap.write2db(data)



if __name__ == "__main__":
    main()

